'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$plugins = _ref.plugins;
  let plugins = _ref$plugins === undefined ? {} : _ref$plugins;


  const stack = [];

  function normalizeError(err) {
    if (err && _lodash2.default.isFunction(err.toJSON)) {
      return err.toJSON();
    }

    return {
      message: err.message
    };
  }

  const dispatcher = (req, res) => {
    return _bluebird2.default.each(stack, call => call(req, res)).catch(err => {
      if (err.nonce) {
        return;
      }
      debug(err);
      res.status(err.status || 500).json(normalizeError(err));
    });
  };

  function registerPlugin(plugin) {
    if (_lodash2.default.isFunction(plugin)) {
      return function () {
        stack.push(plugin(...arguments));
        return dispatcher;
      };
    }

    if (_lodash2.default.isObject(plugin)) {
      const container = {};
      _lodash2.default.forEach(plugin, (name, key) => {
        container[key] = function () {
          stack.push(name(...arguments));
          return dispatcher;
        };
      });

      return container;
    }

    throw new Error(`The provided plugin has invalid type "${ typeof plugin }"`);
  }

  // plugins
  function plugin(name, plugin) {
    if (dispatcher.hasOwnProperty(name)) {
      throw new Error(`The plugin with name ${ name } is already registered or would overwrite a builtin method.`);
    }
    Object.defineProperty(dispatcher, name, {
      value: registerPlugin(plugin)
    });
    return dispatcher;
  }

  Object.defineProperty(dispatcher, 'plugin', {
    value: plugin
  });

  _lodash2.default.forEach(plugins, (fn, name) => plugin(name, fn));

  return dispatcher;
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const debug = (0, _debug2.default)('netiam:dispatcher');